diff --git a/doc/bashref.ps b/doc/bashref.ps
index f754613b..cd7e7a66 100644
--- a/doc/bashref.ps
+++ b/doc/bashref.ps
@@ -17591,280 +17616,280 @@ b(Using)30 b(History)h(In)m(teractiv)m(ely)1925 b(135)870
 299 y Ft(fc)47 b([-e)g Fj(ename)p Ft(])f([-lnr])g([)p
 Fj(first)p Ft(])g([)p Fj(last)p Ft(])870 408 y(fc)h(-s)g([)p
 Fj(pat)p Ft(=)p Fj(rep)p Ft(])f([)p Fj(command)p Ft(])630
-539 y Fu(The)22 b(\014rst)g(form)f(selects)j(a)f(range)g(of)f(commands)
+557 y Fu(The)22 b(\014rst)g(form)f(selects)j(a)f(range)g(of)f(commands)
 g(from)g Fr(\014rst)i Fu(to)f Fr(last)i Fu(from)d(the)h(history)f(list)
-630 648 y(and)i(displa)m(ys)h(or)g(edits)h(and)e(re-executes)j(them.)39
+630 667 y(and)i(displa)m(ys)h(or)g(edits)h(and)e(re-executes)j(them.)39
 b(Both)25 b Fr(\014rst)h Fu(and)f Fr(last)j Fu(ma)m(y)d(b)s(e)g(sp)s
-(eci\014ed)630 758 y(as)31 b(a)g(string)f(\(to)i(lo)s(cate)h(the)d
+(eci\014ed)630 776 y(as)31 b(a)g(string)f(\(to)i(lo)s(cate)h(the)d
 (most)h(recen)m(t)h(command)f(b)s(eginning)e(with)i(that)g(string\))g
-(or)630 867 y(as)d(a)g(n)m(um)m(b)s(er)f(\(an)h(index)f(in)m(to)i(the)f
+(or)630 886 y(as)d(a)g(n)m(um)m(b)s(er)f(\(an)h(index)f(in)m(to)i(the)f
 (history)g(list,)h(where)e(a)h(negativ)m(e)i(n)m(um)m(b)s(er)d(is)h
-(used)f(as)630 977 y(an)g(o\013set)i(from)e(the)h(curren)m(t)f(command)
+(used)f(as)630 996 y(an)g(o\013set)i(from)e(the)h(curren)m(t)f(command)
 h(n)m(um)m(b)s(er\).)39 b(If)27 b Fr(last)j Fu(is)e(not)f(sp)s
-(eci\014ed)g(it)h(is)g(set)g(to)630 1087 y Fr(\014rst)p
+(eci\014ed)g(it)h(is)g(set)g(to)630 1105 y Fr(\014rst)p
 Fu(.)47 b(If)32 b Fr(\014rst)i Fu(is)f(not)g(sp)s(eci\014ed)f(it)h(is)g
 (set)g(to)h(the)f(previous)f(command)h(for)f(editing)i(and)630
-1196 y Fq(\000)p Fu(16)j(for)g(listing.)61 b(If)36 b(the)h
+1215 y Fq(\000)p Fu(16)j(for)g(listing.)61 b(If)36 b(the)h
 Ft(-l)f Fu(\015ag)i(is)e(giv)m(en,)k(the)d(commands)f(are)i(listed)f
-(on)g(standard)630 1306 y(output.)59 b(The)36 b Ft(-n)h
+(on)g(standard)630 1324 y(output.)59 b(The)36 b Ft(-n)h
 Fu(\015ag)g(suppresses)e(the)h(command)h(n)m(um)m(b)s(ers)e(when)h
-(listing.)60 b(The)37 b Ft(-r)630 1415 y Fu(\015ag)e(rev)m(erses)f(the)
+(listing.)60 b(The)37 b Ft(-r)630 1434 y Fu(\015ag)e(rev)m(erses)f(the)
 h(order)e(of)i(the)f(listing.)53 b(Otherwise,)35 b(the)f(editor)h(giv)m
-(en)g(b)m(y)f Fr(ename)40 b Fu(is)630 1525 y(in)m(v)m(ok)m(ed)33
+(en)g(b)m(y)f Fr(ename)40 b Fu(is)630 1543 y(in)m(v)m(ok)m(ed)33
 b(on)f(a)g(\014le)g(con)m(taining)h(those)f(commands.)44
 b(If)31 b Fr(ename)38 b Fu(is)31 b(not)h(giv)m(en,)i(the)d(v)-5
-b(alue)630 1634 y(of)29 b(the)g(follo)m(wing)i(v)-5 b(ariable)29
+b(alue)630 1653 y(of)29 b(the)g(follo)m(wing)i(v)-5 b(ariable)29
 b(expansion)g(is)g(used:)39 b Ft(${FCEDIT:-${EDITOR:-vi}})p
-Fu(.)34 b(This)630 1744 y(sa)m(ys)g(to)g(use)f(the)h(v)-5
+Fu(.)34 b(This)630 1763 y(sa)m(ys)g(to)g(use)f(the)h(v)-5
 b(alue)34 b(of)f(the)h Ft(FCEDIT)e Fu(v)-5 b(ariable)34
 b(if)f(set,)i(or)f(the)f(v)-5 b(alue)34 b(of)g(the)g
-Ft(EDITOR)630 1854 y Fu(v)-5 b(ariable)40 b(if)e(that)i(is)f(set,)i(or)
+Ft(EDITOR)630 1872 y Fu(v)-5 b(ariable)40 b(if)e(that)i(is)f(set,)i(or)
 e Ft(vi)f Fu(if)h(neither)g(is)g(set.)66 b(When)39 b(editing)g(is)g
-(complete,)k(the)630 1963 y(edited)31 b(commands)f(are)g(ec)m(ho)s(ed)h
-(and)f(executed.)630 2093 y(In)k(the)g(second)g(form,)h
+(complete,)k(the)630 1982 y(edited)31 b(commands)f(are)g(ec)m(ho)s(ed)h
+(and)f(executed.)630 2131 y(In)k(the)g(second)g(form,)h
 Fr(command)j Fu(is)c(re-executed)i(after)f(eac)m(h)g(instance)g(of)f
-Fr(pat)j Fu(in)d(the)630 2203 y(selected)e(command)e(is)h(replaced)g(b)
+Fr(pat)j Fu(in)d(the)630 2240 y(selected)e(command)e(is)h(replaced)g(b)
 m(y)f Fr(rep)p Fu(.)41 b Fr(command)34 b Fu(is)c(in)m(tepreted)h(the)g
-(same)g(as)g Fr(\014rst)630 2313 y Fu(ab)s(o)m(v)m(e.)630
-2443 y(A)g(useful)f(alias)i(to)g(use)e(with)h(the)g Ft(fc)f
+(same)g(as)g Fr(\014rst)630 2350 y Fu(ab)s(o)m(v)m(e.)630
+2498 y(A)g(useful)f(alias)i(to)g(use)e(with)h(the)g Ft(fc)f
 Fu(command)h(is)g Ft(r='fc)e(-s')p Fu(,)h(so)h(that)h(t)m(yping)f(`)p
-Ft(r)f(cc)p Fu(')630 2552 y(runs)35 b(the)h(last)h(command)f(b)s
+Ft(r)f(cc)p Fu(')630 2608 y(runs)35 b(the)h(last)h(command)f(b)s
 (eginning)g(with)g Ft(cc)f Fu(and)h(t)m(yping)g(`)p Ft(r)p
-Fu(')h(re-executes)h(the)e(last)630 2662 y(command)30
+Fu(')h(re-executes)h(the)e(last)630 2718 y(command)30
 b(\(see)h(Section)h(6.6)f([Aliases],)h(page)g(88\).)150
-2813 y Ft(history)870 2943 y(history)46 b([)p Fj(n)p
-Ft(])870 3052 y(history)g(-c)870 3162 y(history)g(-d)h
-Fj(offset)870 3271 y Ft(history)f([-anrw])g([)p Fj(filename)p
-Ft(])870 3381 y(history)g(-ps)h Fj(arg)630 3511 y Fu(With)26
+2906 y Ft(history)870 3054 y(history)46 b([)p Fj(n)p
+Ft(])870 3164 y(history)g(-c)870 3273 y(history)g(-d)h
+Fj(offset)870 3383 y Ft(history)f([-anrw])g([)p Fj(filename)p
+Ft(])870 3493 y(history)g(-ps)h Fj(arg)630 3641 y Fu(With)26
 b(no)g(options,)h(displa)m(y)f(the)g(history)g(list)g(with)f(line)h(n)m
 (um)m(b)s(ers.)38 b(Lines)26 b(pre\014xed)e(with)630
-3621 y(a)35 b(`)p Ft(*)p Fu(')g(ha)m(v)m(e)h(b)s(een)e(mo)s(di\014ed.)
+3751 y(a)35 b(`)p Ft(*)p Fu(')g(ha)m(v)m(e)h(b)s(een)e(mo)s(di\014ed.)
 53 b(An)34 b(argumen)m(t)h(of)g Fr(n)f Fu(lists)i(only)f(the)g(last)g
-Fr(n)f Fu(lines.)54 b(If)35 b(the)630 3730 y(shell)30
+Fr(n)f Fu(lines.)54 b(If)35 b(the)630 3861 y(shell)30
 b(v)-5 b(ariable)31 b Ft(HISTTIMEFORMAT)26 b Fu(is)k(set)h(and)e(not)i
 (n)m(ull,)f(it)h(is)f(used)f(as)h(a)h(format)f(string)630
-3840 y(for)36 b Fr(strftime)41 b Fu(to)36 b(displa)m(y)g(the)g(time)h
+3970 y(for)36 b Fr(strftime)41 b Fu(to)36 b(displa)m(y)g(the)g(time)h
 (stamp)f(asso)s(ciated)h(with)f(eac)m(h)h(displa)m(y)m(ed)f(history)630
-3950 y(en)m(try)-8 b(.)47 b(No)33 b(in)m(terv)m(ening)g(blank)f(is)g
+4080 y(en)m(try)-8 b(.)47 b(No)33 b(in)m(terv)m(ening)g(blank)f(is)g
 (prin)m(ted)g(b)s(et)m(w)m(een)h(the)g(formatted)f(time)h(stamp)g(and)
-630 4059 y(the)e(history)f(line.)630 4189 y(Options,)g(if)h(supplied,)e
-(ha)m(v)m(e)i(the)g(follo)m(wing)h(meanings:)630 4340
+630 4189 y(the)e(history)f(line.)630 4338 y(Options,)g(if)h(supplied,)e
+(ha)m(v)m(e)i(the)g(follo)m(wing)h(meanings:)630 4526
 y Ft(-c)384 b Fu(Clear)23 b(the)g(history)g(list.)39
 b(This)22 b(ma)m(y)i(b)s(e)e(com)m(bined)h(with)f(the)h(other)h
-(options)1110 4450 y(to)31 b(replace)g(the)g(history)f(list)h
-(completely)-8 b(.)630 4600 y Ft(-d)30 b Fj(offset)66
+(options)1110 4635 y(to)31 b(replace)g(the)g(history)f(list)h
+(completely)-8 b(.)630 4823 y Ft(-d)30 b Fj(offset)66
 b Fu(Delete)25 b(the)f(history)f(en)m(try)h(at)g(p)s(osition)f
 Fr(o\013set)p Fu(.)39 b Fr(o\013set)27 b Fu(should)22
-b(b)s(e)h(sp)s(eci\014ed)1110 4710 y(as)31 b(it)g(app)s(ears)e(when)h
-(the)g(history)g(is)h(displa)m(y)m(ed.)630 4861 y Ft(-a)384
-b Fu(App)s(end)35 b(the)i(new)g(history)g(lines)g(\(history)g(lines)g
-(en)m(tered)h(since)f(the)g(b)s(e-)1110 4970 y(ginning)30
-b(of)h(the)f(curren)m(t)g(Bash)h(session\))g(to)g(the)g(history)f
-(\014le.)630 5121 y Ft(-n)384 b Fu(App)s(end)32 b(the)i(history)f
-(lines)h(not)g(already)g(read)g(from)f(the)h(history)f(\014le)h(to)1110
-5230 y(the)26 b(curren)m(t)f(history)g(list.)40 b(These)25
-b(are)h(lines)g(app)s(ended)e(to)i(the)f(history)h(\014le)1110
-5340 y(since)31 b(the)f(b)s(eginning)g(of)g(the)h(curren)m(t)f(Bash)h
-(session.)p eop end
+b(b)s(e)h(sp)s(eci\014ed)1110 4933 y(as)31 b(it)g(app)s(ears)e(when)h
+(the)g(history)g(is)h(displa)m(y)m(ed.)630 5121 y Ft(-a)384
+b Fu(App)s(end)28 b(the)i(new)f(history)g(lines)h(to)h(the)e(history)h
+(\014le.)41 b(These)29 b(are)h(history)1110 5230 y(lines)36
+b(en)m(tered)g(since)f(the)h(b)s(eginning)f(of)g(the)h(curren)m(t)f
+(Bash)h(session,)h(but)1110 5340 y(not)31 b(already)g(app)s(ended)d(to)
+j(the)g(history)f(\014le.)p eop end
 %%Page: 136 142
 TeXDict begin 136 141 bop 150 -116 a Fu(Chapter)30 b(9:)41
 b(Using)30 b(History)h(In)m(teractiv)m(ely)1925 b(136)630
-299 y Ft(-r)384 b Fu(Read)31 b(the)f(history)g(\014le)h(and)f(app)s
-(end)e(its)j(con)m(ten)m(ts)h(to)f(the)g(history)f(list.)630
-447 y Ft(-w)384 b Fu(W)-8 b(rite)32 b(out)e(the)h(curren)m(t)f(history)
-g(list)h(to)h(the)e(history)g(\014le.)630 595 y Ft(-p)384
-b Fu(P)m(erform)31 b(history)f(substitution)h(on)f(the)h
+299 y Ft(-n)384 b Fu(App)s(end)32 b(the)i(history)f(lines)h(not)g
+(already)g(read)g(from)f(the)h(history)f(\014le)h(to)1110
+408 y(the)26 b(curren)m(t)f(history)g(list.)40 b(These)25
+b(are)h(lines)g(app)s(ended)e(to)i(the)f(history)h(\014le)1110
+518 y(since)31 b(the)f(b)s(eginning)g(of)g(the)h(curren)m(t)f(Bash)h
+(session.)630 666 y Ft(-r)384 b Fu(Read)31 b(the)f(history)g(\014le)h
+(and)f(app)s(end)e(its)j(con)m(ten)m(ts)h(to)f(the)g(history)f(list.)
+630 815 y Ft(-w)384 b Fu(W)-8 b(rite)32 b(out)e(the)h(curren)m(t)f
+(history)g(list)h(to)h(the)e(history)g(\014le.)630 963
+y Ft(-p)384 b Fu(P)m(erform)31 b(history)f(substitution)h(on)f(the)h
 Fr(arg)8 b Fu(s)31 b(and)f(displa)m(y)h(the)f(result)h(on)1110
-705 y(the)d(standard)f(output,)i(without)f(storing)g(the)g(results)g
-(in)g(the)g(history)g(list.)630 853 y Ft(-s)384 b Fu(The)30
+1072 y(the)d(standard)f(output,)i(without)f(storing)g(the)g(results)g
+(in)g(the)g(history)g(list.)630 1221 y Ft(-s)384 b Fu(The)30
 b Fr(arg)8 b Fu(s)30 b(are)h(added)f(to)h(the)f(end)g(of)h(the)f
 (history)h(list)g(as)f(a)h(single)g(en)m(try)-8 b(.)630
-1001 y(When)26 b(an)m(y)h(of)f(the)g Ft(-w)p Fu(,)h Ft(-r)p
+1369 y(When)26 b(an)m(y)h(of)f(the)g Ft(-w)p Fu(,)h Ft(-r)p
 Fu(,)g Ft(-a)p Fu(,)g(or)f Ft(-n)f Fu(options)i(is)f(used,)h(if)f
 Fr(\014lename)32 b Fu(is)26 b(giv)m(en,)i(then)e(it)h(is)630
-1111 y(used)h(as)g(the)h(history)f(\014le.)40 b(If)28
+1478 y(used)h(as)g(the)h(history)f(\014le.)40 b(If)28
 b(not,)i(then)e(the)g(v)-5 b(alue)29 b(of)g(the)g Ft(HISTFILE)d
-Fu(v)-5 b(ariable)29 b(is)f(used.)150 1332 y Fs(9.3)68
-b(History)46 b(Expansion)150 1492 y Fu(The)f(History)h(library)e(pro)m
+Fu(v)-5 b(ariable)29 b(is)f(used.)150 1700 y Fs(9.3)68
+b(History)46 b(Expansion)150 1859 y Fu(The)f(History)h(library)e(pro)m
 (vides)i(a)f(history)g(expansion)g(feature)h(that)g(is)f(similar)h(to)g
-(the)f(history)150 1601 y(expansion)g(pro)m(vided)f(b)m(y)h
+(the)f(history)150 1969 y(expansion)g(pro)m(vided)f(b)m(y)h
 Ft(csh)p Fu(.)83 b(This)44 b(section)i(describ)s(es)e(the)h(syn)m(tax)h
-(used)e(to)i(manipulate)f(the)150 1711 y(history)30 b(information.)275
-1840 y(History)h(expansions)f(in)m(tro)s(duce)g(w)m(ords)g(from)g(the)h
+(used)e(to)i(manipulate)f(the)150 2078 y(history)30 b(information.)275
+2207 y(History)h(expansions)f(in)m(tro)s(duce)g(w)m(ords)g(from)g(the)h
 (history)f(list)h(in)m(to)g(the)g(input)f(stream,)h(making)150
-1949 y(it)g(easy)g(to)g(rep)s(eat)g(commands,)f(insert)g(the)h(argumen)
+2317 y(it)g(easy)g(to)g(rep)s(eat)g(commands,)f(insert)g(the)h(argumen)
 m(ts)f(to)h(a)g(previous)f(command)g(in)m(to)i(the)e(curren)m(t)150
-2059 y(input)f(line,)i(or)g(\014x)f(errors)f(in)h(previous)g(commands)g
-(quic)m(kly)-8 b(.)275 2188 y(History)27 b(expansion)f(tak)m(es)i
+2426 y(input)f(line,)i(or)g(\014x)f(errors)f(in)h(previous)g(commands)g
+(quic)m(kly)-8 b(.)275 2555 y(History)27 b(expansion)f(tak)m(es)i
 (place)f(in)f(t)m(w)m(o)i(parts.)39 b(The)26 b(\014rst)g(is)g(to)h
-(determine)g(whic)m(h)f(line)h(from)f(the)150 2297 y(history)i(list)g
+(determine)g(whic)m(h)f(line)h(from)f(the)150 2665 y(history)i(list)g
 (should)f(b)s(e)g(used)g(during)g(substitution.)39 b(The)27
 b(second)h(is)g(to)h(select)g(p)s(ortions)e(of)h(that)h(line)150
-2407 y(for)d(inclusion)f(in)m(to)i(the)f(curren)m(t)f(one.)40
+2775 y(for)d(inclusion)f(in)m(to)i(the)f(curren)m(t)f(one.)40
 b(The)25 b(line)h(selected)h(from)f(the)g(history)f(is)h(called)h(the)f
-Fr(ev)m(en)m(t)p Fu(,)j(and)150 2517 y(the)21 b(p)s(ortions)g(of)g
+Fr(ev)m(en)m(t)p Fu(,)j(and)150 2884 y(the)21 b(p)s(ortions)g(of)g
 (that)h(line)f(that)h(are)g(acted)g(up)s(on)e(are)h(called)h
 Fr(w)m(ords)p Fu(.)38 b(V)-8 b(arious)21 b Fr(mo)s(di\014ers)j
-Fu(are)e(a)m(v)-5 b(ailable)150 2626 y(to)35 b(manipulate)f(the)g
+Fu(are)e(a)m(v)-5 b(ailable)150 2994 y(to)35 b(manipulate)f(the)g
 (selected)i(w)m(ords.)51 b(The)33 b(line)h(is)g(brok)m(en)g(in)m(to)h
-(w)m(ords)e(in)h(the)g(same)h(fashion)e(that)150 2736
+(w)m(ords)e(in)h(the)g(same)h(fashion)e(that)150 3103
 y(Bash)i(do)s(es,)h(so)f(that)h(sev)m(eral)g(w)m(ords)e(surrounded)f(b)
 m(y)i(quotes)g(are)g(considered)g(one)g(w)m(ord.)54 b(History)150
-2845 y(expansions)34 b(are)g(in)m(tro)s(duced)f(b)m(y)h(the)g(app)s
+3213 y(expansions)34 b(are)g(in)m(tro)s(duced)f(b)m(y)h(the)g(app)s
 (earance)g(of)g(the)g(history)g(expansion)g(c)m(haracter,)i(whic)m(h)e
-(is)150 2955 y(`)p Ft(!)p Fu(')d(b)m(y)f(default.)41
+(is)150 3322 y(`)p Ft(!)p Fu(')d(b)m(y)f(default.)41
 b(Only)29 b(`)p Ft(\\)p Fu(')i(and)f(`)p Ft(')p Fu(')g(ma)m(y)h(b)s(e)f
 (used)g(to)h(escap)s(e)g(the)f(history)g(expansion)h(c)m(haracter.)275
-3084 y(Sev)m(eral)40 b(shell)g(options)g(settable)h(with)e(the)h
+3451 y(Sev)m(eral)40 b(shell)g(options)g(settable)h(with)e(the)h
 Ft(shopt)e Fu(builtin)h(\(see)h(Section)h(4.2)f([Bash)g(Builtins],)150
-3194 y(page)32 b(48\))h(ma)m(y)f(b)s(e)f(used)g(to)i(tailor)g(the)e(b)s
+3561 y(page)32 b(48\))h(ma)m(y)f(b)s(e)f(used)g(to)i(tailor)g(the)e(b)s
 (eha)m(vior)h(of)g(history)g(expansion.)44 b(If)31 b(the)h
-Ft(histverify)d Fu(shell)150 3303 y(option)39 b(is)f(enabled,)i(and)e
+Ft(histverify)d Fu(shell)150 3671 y(option)39 b(is)f(enabled,)i(and)e
 (Readline)g(is)h(b)s(eing)e(used,)j(history)e(substitutions)g(are)g
-(not)h(immediately)150 3413 y(passed)30 b(to)h(the)g(shell)g(parser.)40
+(not)h(immediately)150 3780 y(passed)30 b(to)h(the)g(shell)g(parser.)40
 b(Instead,)30 b(the)h(expanded)f(line)h(is)f(reloaded)h(in)m(to)h(the)e
-(Readline)h(editing)150 3522 y(bu\013er)e(for)i(further)e(mo)s
+(Readline)h(editing)150 3890 y(bu\013er)e(for)i(further)e(mo)s
 (di\014cation.)41 b(If)30 b(Readline)h(is)f(b)s(eing)g(used,)g(and)g
-(the)g Ft(histreedit)e Fu(shell)i(option)150 3632 y(is)k(enabled,)h(a)g
+(the)g Ft(histreedit)e Fu(shell)i(option)150 3999 y(is)k(enabled,)h(a)g
 (failed)g(history)f(expansion)g(will)g(b)s(e)g(reloaded)g(in)m(to)h
-(the)g(Readline)f(editing)h(bu\013er)e(for)150 3741 y(correction.)68
+(the)g(Readline)f(editing)h(bu\013er)e(for)150 4109 y(correction.)68
 b(The)38 b Ft(-p)h Fu(option)g(to)h(the)f Ft(history)e
 Fu(builtin)i(command)f(ma)m(y)i(b)s(e)e(used)g(to)i(see)g(what)f(a)150
-3851 y(history)f(expansion)f(will)h(do)g(b)s(efore)f(using)h(it.)63
+4218 y(history)f(expansion)f(will)h(do)g(b)s(efore)f(using)h(it.)63
 b(The)37 b Ft(-s)g Fu(option)i(to)f(the)g Ft(history)e
-Fu(builtin)h(ma)m(y)i(b)s(e)150 3961 y(used)21 b(to)i(add)f(commands)g
+Fu(builtin)h(ma)m(y)i(b)s(e)150 4328 y(used)21 b(to)i(add)f(commands)g
 (to)g(the)h(end)e(of)i(the)f(history)g(list)h(without)f(actually)i
-(executing)f(them,)h(so)e(that)150 4070 y(they)31 b(are)f(a)m(v)-5
+(executing)f(them,)h(so)e(that)150 4438 y(they)31 b(are)f(a)m(v)-5
 b(ailable)33 b(for)d(subsequen)m(t)g(recall.)42 b(This)29
 b(is)i(most)g(useful)e(in)h(conjunction)h(with)f(Readline.)275
-4199 y(The)j(shell)h(allo)m(ws)h(con)m(trol)h(of)e(the)g(v)-5
+4567 y(The)j(shell)h(allo)m(ws)h(con)m(trol)h(of)e(the)g(v)-5
 b(arious)34 b(c)m(haracters)h(used)f(b)m(y)f(the)h(history)g(expansion)
-g(mec)m(h-)150 4309 y(anism)h(with)g(the)g Ft(histchars)d
+g(mec)m(h-)150 4676 y(anism)h(with)g(the)g Ft(histchars)d
 Fu(v)-5 b(ariable,)38 b(as)d(explained)g(ab)s(o)m(v)m(e)i(\(see)f
-(Section)f(5.2)i([Bash)e(V)-8 b(ariables],)150 4418 y(page)32
+(Section)f(5.2)i([Bash)e(V)-8 b(ariables],)150 4786 y(page)32
 b(69\).)44 b(The)31 b(shell)g(uses)g(the)g(history)g(commen)m(t)i(c)m
 (haracter)f(to)g(mark)f(history)g(timestamps)h(when)150
-4528 y(writing)e(the)h(history)f(\014le.)150 4716 y Fk(9.3.1)63
-b(Ev)m(en)m(t)39 b(Designators)150 4863 y Fu(An)32 b(ev)m(en)m(t)j
+4895 y(writing)e(the)h(history)f(\014le.)150 5083 y Fk(9.3.1)63
+b(Ev)m(en)m(t)39 b(Designators)150 5230 y Fu(An)32 b(ev)m(en)m(t)j
 (designator)e(is)g(a)g(reference)g(to)h(a)f(command)f(line)h(en)m(try)g
 (in)g(the)g(history)g(list.)48 b(Unless)33 b(the)150
-4973 y(reference)e(is)f(absolute,)i(ev)m(en)m(ts)f(are)g(relativ)m(e)i
-(to)e(the)f(curren)m(t)g(p)s(osition)h(in)f(the)h(history)f(list.)150
-5121 y Ft(!)432 b Fu(Start)34 b(a)f(history)h(substitution,)g(except)g
-(when)f(follo)m(w)m(ed)i(b)m(y)e(a)h(space,)h(tab,)f(the)g(end)f(of)630
-5230 y(the)i(line,)g(`)p Ft(=)p Fu(')g(or)f(`)p Ft(\()p
-Fu(')h(\(when)e(the)i Ft(extglob)d Fu(shell)j(option)f(is)h(enabled)f
-(using)g(the)g Ft(shopt)630 5340 y Fu(builtin\).)p eop
-end
+5340 y(reference)e(is)f(absolute,)i(ev)m(en)m(ts)f(are)g(relativ)m(e)i
+(to)e(the)f(curren)m(t)g(p)s(osition)h(in)f(the)h(history)f(list.)p
+eop end
 %%Page: 137 143
 TeXDict begin 137 142 bop 150 -116 a Fu(Chapter)30 b(9:)41
 b(Using)30 b(History)h(In)m(teractiv)m(ely)1925 b(137)150
-299 y Ft(!)p Fj(n)384 b Fu(Refer)30 b(to)i(command)e(line)g
-Fr(n)p Fu(.)150 460 y Ft(!-)p Fj(n)336 b Fu(Refer)30
+299 y Ft(!)432 b Fu(Start)34 b(a)f(history)h(substitution,)g(except)g
+(when)f(follo)m(w)m(ed)i(b)m(y)e(a)h(space,)h(tab,)f(the)g(end)f(of)630
+408 y(the)i(line,)g(`)p Ft(=)p Fu(')g(or)f(`)p Ft(\()p
+Fu(')h(\(when)e(the)i Ft(extglob)d Fu(shell)j(option)f(is)h(enabled)f
+(using)g(the)g Ft(shopt)630 518 y Fu(builtin\).)150 669
+y Ft(!)p Fj(n)384 b Fu(Refer)30 b(to)i(command)e(line)g
+Fr(n)p Fu(.)150 819 y Ft(!-)p Fj(n)336 b Fu(Refer)30
 b(to)i(the)e(command)g Fr(n)g Fu(lines)h(bac)m(k.)150
-622 y Ft(!!)384 b Fu(Refer)30 b(to)i(the)e(previous)g(command.)40
+970 y Ft(!!)384 b Fu(Refer)30 b(to)i(the)e(previous)g(command.)40
 b(This)30 b(is)g(a)h(synon)m(ym)f(for)g(`)p Ft(!-1)p
-Fu('.)150 784 y Ft(!)p Fj(string)144 b Fu(Refer)25 b(to)h(the)f(most)h
+Fu('.)150 1120 y Ft(!)p Fj(string)144 b Fu(Refer)25 b(to)h(the)f(most)h
 (recen)m(t)g(command)f(preceding)g(the)g(curren)m(t)g(p)s(osition)g(in)
-g(the)g(history)630 893 y(list)31 b(starting)g(with)f
-Fr(string)p Fu(.)150 1055 y Ft(!?)p Fj(string)p Ft([?])630
-1164 y Fu(Refer)25 b(to)h(the)f(most)h(recen)m(t)g(command)f(preceding)
+g(the)g(history)630 1230 y(list)31 b(starting)g(with)f
+Fr(string)p Fu(.)150 1381 y Ft(!?)p Fj(string)p Ft([?])630
+1490 y Fu(Refer)25 b(to)h(the)f(most)h(recen)m(t)g(command)f(preceding)
 g(the)g(curren)m(t)g(p)s(osition)g(in)g(the)g(history)630
-1274 y(list)32 b(con)m(taining)i Fr(string)p Fu(.)45
+1600 y(list)32 b(con)m(taining)i Fr(string)p Fu(.)45
 b(The)31 b(trailing)i(`)p Ft(?)p Fu(')f(ma)m(y)g(b)s(e)f(omitted)i(if)f
-(the)g Fr(string)39 b Fu(is)32 b(follo)m(w)m(ed)630 1384
-y(immediately)g(b)m(y)e(a)h(newline.)150 1545 y Ft(^)p
-Fj(string1)p Ft(^)p Fj(string2)p Ft(^)630 1655 y Fu(Quic)m(k)h
+(the)g Fr(string)39 b Fu(is)32 b(follo)m(w)m(ed)630 1709
+y(immediately)g(b)m(y)e(a)h(newline.)150 1860 y Ft(^)p
+Fj(string1)p Ft(^)p Fj(string2)p Ft(^)630 1970 y Fu(Quic)m(k)h
 (Substitution.)44 b(Rep)s(eat)32 b(the)g(last)h(command,)f(replacing)g
-Fr(string1)40 b Fu(with)31 b Fr(string2)p Fu(.)630 1764
+Fr(string1)40 b Fu(with)31 b Fr(string2)p Fu(.)630 2079
 y(Equiv)-5 b(alen)m(t)31 b(to)g Ft(!!:s/)p Fj(string1)p
-Ft(/)p Fj(string2)p Ft(/)p Fu(.)150 1926 y Ft(!#)384
+Ft(/)p Fj(string2)p Ft(/)p Fu(.)150 2230 y Ft(!#)384
 b Fu(The)30 b(en)m(tire)h(command)f(line)h(t)m(yp)s(ed)f(so)h(far.)150
-2127 y Fk(9.3.2)63 b(W)-10 b(ord)41 b(Designators)150
-2274 y Fu(W)-8 b(ord)27 b(designators)h(are)g(used)e(to)i(select)h
+2420 y Fk(9.3.2)63 b(W)-10 b(ord)41 b(Designators)150
+2567 y Fu(W)-8 b(ord)27 b(designators)h(are)g(used)e(to)i(select)h
 (desired)d(w)m(ords)h(from)f(the)i(ev)m(en)m(t.)41 b(A)27
 b(`)p Ft(:)p Fu(')g(separates)h(the)f(ev)m(en)m(t)150
-2384 y(sp)s(eci\014cation)38 b(from)e(the)h(w)m(ord)f(designator.)61
+2677 y(sp)s(eci\014cation)38 b(from)e(the)h(w)m(ord)f(designator.)61
 b(It)37 b(ma)m(y)h(b)s(e)e(omitted)i(if)e(the)h(w)m(ord)g(designator)g
-(b)s(egins)150 2494 y(with)30 b(a)g(`)p Ft(^)p Fu(',)g(`)p
+(b)s(egins)150 2786 y(with)30 b(a)g(`)p Ft(^)p Fu(',)g(`)p
 Ft($)p Fu(',)g(`)p Ft(*)p Fu(',)h(`)p Ft(-)p Fu(',)f(or)g(`)p
 Ft(\045)p Fu('.)41 b(W)-8 b(ords)30 b(are)g(n)m(um)m(b)s(ered)e(from)i
 (the)g(b)s(eginning)f(of)h(the)g(line,)g(with)g(the)150
-2603 y(\014rst)f(w)m(ord)f(b)s(eing)h(denoted)h(b)m(y)f(0)h(\(zero\).)
+2896 y(\014rst)f(w)m(ord)f(b)s(eing)h(denoted)h(b)m(y)f(0)h(\(zero\).)
 41 b(W)-8 b(ords)30 b(are)g(inserted)f(in)m(to)h(the)g(curren)m(t)f
-(line)g(separated)h(b)m(y)150 2713 y(single)h(spaces.)275
-2849 y(F)-8 b(or)31 b(example,)150 3012 y Ft(!!)384 b
+(line)g(separated)h(b)m(y)150 3005 y(single)h(spaces.)275
+3136 y(F)-8 b(or)31 b(example,)150 3286 y Ft(!!)384 b
 Fu(designates)37 b(the)f(preceding)g(command.)57 b(When)35
 b(y)m(ou)i(t)m(yp)s(e)f(this,)h(the)f(preceding)g(com-)630
-3122 y(mand)30 b(is)g(rep)s(eated)g(in)g(toto.)150 3283
+3396 y(mand)30 b(is)g(rep)s(eated)g(in)g(toto.)150 3546
 y Ft(!!:$)288 b Fu(designates)23 b(the)g(last)g(argumen)m(t)g(of)f(the)
 h(preceding)f(command.)38 b(This)22 b(ma)m(y)h(b)s(e)e(shortened)630
-3393 y(to)31 b Ft(!$)p Fu(.)150 3555 y Ft(!fi:2)240 b
+3656 y(to)31 b Ft(!$)p Fu(.)150 3806 y Ft(!fi:2)240 b
 Fu(designates)30 b(the)g(second)f(argumen)m(t)h(of)f(the)h(most)f
-(recen)m(t)i(command)e(starting)h(with)f(the)630 3664
-y(letters)j Ft(fi)p Fu(.)275 3827 y(Here)e(are)h(the)g(w)m(ord)f
-(designators:)150 3990 y Ft(0)g(\(zero\))114 b Fu(The)30
+(recen)m(t)i(command)e(starting)h(with)f(the)630 3916
+y(letters)j Ft(fi)p Fu(.)275 4067 y(Here)e(are)h(the)g(w)m(ord)f
+(designators:)150 4217 y Ft(0)g(\(zero\))114 b Fu(The)30
 b Ft(0)p Fu(th)g(w)m(ord.)40 b(F)-8 b(or)31 b(man)m(y)g(applications,)h
-(this)e(is)g(the)h(command)f(w)m(ord.)150 4151 y Fj(n)432
-b Fu(The)30 b Fr(n)p Fu(th)g(w)m(ord.)150 4313 y Ft(^)432
+(this)e(is)g(the)h(command)f(w)m(ord.)150 4368 y Fj(n)432
+b Fu(The)30 b Fr(n)p Fu(th)g(w)m(ord.)150 4518 y Ft(^)432
 b Fu(The)30 b(\014rst)f(argumen)m(t;)j(that)f(is,)f(w)m(ord)g(1.)150
-4474 y Ft($)432 b Fu(The)30 b(last)h(argumen)m(t.)150
-4636 y Ft(\045)432 b Fu(The)30 b(w)m(ord)g(matc)m(hed)h(b)m(y)f(the)h
+4669 y Ft($)432 b Fu(The)30 b(last)h(argumen)m(t.)150
+4820 y Ft(\045)432 b Fu(The)30 b(w)m(ord)g(matc)m(hed)h(b)m(y)f(the)h
 (most)g(recen)m(t)g(`)p Ft(?)p Fj(string)p Ft(?)p Fu(')e(searc)m(h.)150
-4798 y Fj(x)p Ft(-)p Fj(y)336 b Fu(A)30 b(range)h(of)g(w)m(ords;)f(`)p
+4970 y Fj(x)p Ft(-)p Fj(y)336 b Fu(A)30 b(range)h(of)g(w)m(ords;)f(`)p
 Ft(-)p Fj(y)p Fu(')g(abbreviates)h(`)p Ft(0-)p Fj(y)p
-Fu('.)150 4959 y Ft(*)432 b Fu(All)28 b(of)g(the)g(w)m(ords,)g(except)h
+Fu('.)150 5121 y Ft(*)432 b Fu(All)28 b(of)g(the)g(w)m(ords,)g(except)h
 (the)e Ft(0)p Fu(th.)40 b(This)27 b(is)g(a)h(synon)m(ym)f(for)h(`)p
 Ft(1-$)p Fu('.)39 b(It)28 b(is)g(not)g(an)f(error)630
-5069 y(to)j(use)g(`)p Ft(*)p Fu(')f(if)h(there)g(is)g(just)f(one)h(w)m
+5230 y(to)j(use)g(`)p Ft(*)p Fu(')f(if)h(there)g(is)g(just)f(one)h(w)m
 (ord)f(in)g(the)h(ev)m(en)m(t;)i(the)d(empt)m(y)i(string)e(is)h
-(returned)e(in)630 5178 y(that)j(case.)150 5340 y Fj(x)p
-Ft(*)384 b Fu(Abbreviates)31 b(`)p Fj(x)p Ft(-$)p Fu(')p
-eop end
+(returned)e(in)630 5340 y(that)j(case.)p eop end
 %%Page: 138 144
 TeXDict begin 138 143 bop 150 -116 a Fu(Chapter)30 b(9:)41
 b(Using)30 b(History)h(In)m(teractiv)m(ely)1925 b(138)150
-299 y Fj(x)p Ft(-)384 b Fu(Abbreviates)31 b(`)p Fj(x)p
-Ft(-$)p Fu(')f(lik)m(e)h(`)p Fj(x)p Ft(*)p Fu(',)g(but)f(omits)h(the)f
-(last)h(w)m(ord.)275 458 y(If)i(a)h(w)m(ord)g(designator)g(is)g
-(supplied)f(without)h(an)g(ev)m(en)m(t)h(sp)s(eci\014cation,)h(the)e
-(previous)f(command)150 568 y(is)d(used)g(as)h(the)f(ev)m(en)m(t.)150
-767 y Fk(9.3.3)63 b(Mo)s(di\014ers)150 914 y Fu(After)29
-b(the)g(optional)g(w)m(ord)g(designator,)g(y)m(ou)g(can)g(add)f(a)h
-(sequence)g(of)g(one)g(or)f(more)h(of)g(the)f(follo)m(wing)150
-1024 y(mo)s(di\014ers,)h(eac)m(h)j(preceded)e(b)m(y)g(a)h(`)p
-Ft(:)p Fu('.)150 1183 y Ft(h)432 b Fu(Remo)m(v)m(e)32
+299 y Fj(x)p Ft(*)384 b Fu(Abbreviates)31 b(`)p Fj(x)p
+Ft(-$)p Fu(')150 458 y Fj(x)p Ft(-)384 b Fu(Abbreviates)31
+b(`)p Fj(x)p Ft(-$)p Fu(')f(lik)m(e)h(`)p Fj(x)p Ft(*)p
+Fu(',)g(but)f(omits)h(the)f(last)h(w)m(ord.)275 618 y(If)i(a)h(w)m(ord)
+g(designator)g(is)g(supplied)f(without)h(an)g(ev)m(en)m(t)h(sp)s
+(eci\014cation,)h(the)e(previous)f(command)150 727 y(is)d(used)g(as)h
+(the)f(ev)m(en)m(t.)150 927 y Fk(9.3.3)63 b(Mo)s(di\014ers)150
+1073 y Fu(After)29 b(the)g(optional)g(w)m(ord)g(designator,)g(y)m(ou)g
+(can)g(add)f(a)h(sequence)g(of)g(one)g(or)f(more)h(of)g(the)f(follo)m
+(wing)150 1183 y(mo)s(di\014ers,)h(eac)m(h)j(preceded)e(b)m(y)g(a)h(`)p
+Ft(:)p Fu('.)150 1342 y Ft(h)432 b Fu(Remo)m(v)m(e)32
 b(a)f(trailing)g(pathname)g(comp)s(onen)m(t,)g(lea)m(ving)h(only)e(the)
-h(head.)150 1342 y Ft(t)432 b Fu(Remo)m(v)m(e)32 b(all)f(leading)h
+h(head.)150 1502 y Ft(t)432 b Fu(Remo)m(v)m(e)32 b(all)f(leading)h
 (pathname)e(comp)s(onen)m(ts,)h(lea)m(ving)h(the)e(tail.)150
-1502 y Ft(r)432 b Fu(Remo)m(v)m(e)32 b(a)f(trailing)g(su\016x)f(of)g
+1661 y Ft(r)432 b Fu(Remo)m(v)m(e)32 b(a)f(trailing)g(su\016x)f(of)g
 (the)h(form)f(`)p Ft(.)p Fj(suffix)p Fu(',)f(lea)m(ving)j(the)f
-(basename.)150 1661 y Ft(e)432 b Fu(Remo)m(v)m(e)32 b(all)f(but)f(the)h
-(trailing)g(su\016x.)150 1821 y Ft(p)432 b Fu(Prin)m(t)30
+(basename.)150 1821 y Ft(e)432 b Fu(Remo)m(v)m(e)32 b(all)f(but)f(the)h
+(trailing)g(su\016x.)150 1980 y Ft(p)432 b Fu(Prin)m(t)30
 b(the)h(new)f(command)g(but)g(do)g(not)g(execute)i(it.)150
-1980 y Ft(q)432 b Fu(Quote)31 b(the)f(substituted)g(w)m(ords,)g
-(escaping)h(further)e(substitutions.)150 2139 y Ft(x)432
+2139 y Ft(q)432 b Fu(Quote)31 b(the)f(substituted)g(w)m(ords,)g
+(escaping)h(further)e(substitutions.)150 2299 y Ft(x)432
 b Fu(Quote)32 b(the)f(substituted)g(w)m(ords)f(as)i(with)f(`)p
 Ft(q)p Fu(',)h(but)e(break)h(in)m(to)i(w)m(ords)d(at)i(spaces,)h(tabs,)
-630 2249 y(and)d(newlines.)150 2408 y Ft(s/)p Fj(old)p
-Ft(/)p Fj(new)p Ft(/)630 2518 y Fu(Substitute)i Fr(new)40
+630 2408 y(and)d(newlines.)150 2568 y Ft(s/)p Fj(old)p
+Ft(/)p Fj(new)p Ft(/)630 2677 y Fu(Substitute)i Fr(new)40
 b Fu(for)32 b(the)h(\014rst)f(o)s(ccurrence)h(of)f Fr(old)37
 b Fu(in)32 b(the)h(ev)m(en)m(t)h(line.)48 b(An)m(y)32
-b(delimiter)630 2628 y(ma)m(y)25 b(b)s(e)g(used)f(in)g(place)i(of)f(`)p
+b(delimiter)630 2787 y(ma)m(y)25 b(b)s(e)g(used)f(in)g(place)i(of)f(`)p
 Ft(/)p Fu('.)39 b(The)24 b(delimiter)h(ma)m(y)h(b)s(e)e(quoted)h(in)f
 Fr(old)29 b Fu(and)24 b Fr(new)32 b Fu(with)25 b(a)630
-2737 y(single)k(bac)m(kslash.)40 b(If)28 b(`)p Ft(&)p
+2897 y(single)k(bac)m(kslash.)40 b(If)28 b(`)p Ft(&)p
 Fu(')g(app)s(ears)g(in)f Fr(new)p Fu(,)i(it)f(is)h(replaced)f(b)m(y)g
-Fr(old)p Fu(.)40 b(A)28 b(single)h(bac)m(kslash)630 2847
+Fr(old)p Fu(.)40 b(A)28 b(single)h(bac)m(kslash)630 3006
 y(will)35 b(quote)g(the)g(`)p Ft(&)p Fu('.)54 b(The)34
 b(\014nal)g(delimiter)i(is)e(optional)i(if)f(it)g(is)f(the)h(last)h(c)m
-(haracter)g(on)630 2956 y(the)31 b(input)e(line.)150
-3116 y Ft(&)432 b Fu(Rep)s(eat)31 b(the)f(previous)g(substitution.)150
-3275 y Ft(g)150 3385 y(a)432 b Fu(Cause)38 b(c)m(hanges)i(to)f(b)s(e)f
+(haracter)g(on)630 3116 y(the)31 b(input)e(line.)150
+3275 y Ft(&)432 b Fu(Rep)s(eat)31 b(the)f(previous)g(substitution.)150
+3435 y Ft(g)150 3544 y(a)432 b Fu(Cause)38 b(c)m(hanges)i(to)f(b)s(e)f
 (applied)h(o)m(v)m(er)h(the)f(en)m(tire)g(ev)m(en)m(t)h(line.)66
-b(Used)39 b(in)f(conjunction)630 3494 y(with)30 b(`)p
+b(Used)39 b(in)f(conjunction)630 3654 y(with)30 b(`)p
 Ft(s)p Fu(',)h(as)f(in)h Ft(gs/)p Fj(old)p Ft(/)p Fj(new)p
-Ft(/)p Fu(,)c(or)j(with)h(`)p Ft(&)p Fu('.)150 3654 y
+Ft(/)p Fu(,)c(or)j(with)h(`)p Ft(&)p Fu('.)150 3813 y
 Ft(G)432 b Fu(Apply)30 b(the)g(follo)m(wing)i(`)p Ft(s)p
 Fu(')f(mo)s(di\014er)e(once)i(to)g(eac)m(h)h(w)m(ord)e(in)g(the)g(ev)m
 (en)m(t.)p eop end
@@ -19542,7 +19567,7 @@ g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g
 49 b Fb(48)150 2580 y Fe(break)21 b Fc(:)13 b(:)g(:)g(:)g(:)g(:)h(:)f
 (:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)
 g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)46
-b Fb(41)150 2668 y Fe(builtin)15 b Fc(:)f(:)f(:)h(:)f(:)g(:)g(:)g(:)g
+b Fb(42)150 2668 y Fe(builtin)15 b Fc(:)f(:)f(:)h(:)f(:)g(:)g(:)g(:)g
 (:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)
 h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)41
 b Fb(49)150 2902 y Fs(C)150 3019 y Fe(caller)17 b Fc(:)e(:)e(:)g(:)g(:)
@@ -19587,7 +19612,7 @@ b Fc(:)13 b(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g
 h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)49 b Fb(42)150 4682 y
 Fe(exec)23 b Fc(:)13 b(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g
 (:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)
-g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)49 b Fb(42)150
+g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)49 b Fb(43)150
 4770 y Fe(exit)23 b Fc(:)13 b(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h
 (:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)
 g(:)g(:)g(:)g(:)g(:)h(:)f(:)g(:)g(:)g(:)g(:)g(:)g(:)49
